#if !defined(AFX_DLGBREAKPOINTS_H__431AD5E5_9522_4F2B_A870_7962BDF479CB__INCLUDED_)
#define AFX_DLGBREAKPOINTS_H__431AD5E5_9522_4F2B_A870_7962BDF479CB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgBreakPoints.h : header file
//

#include "CESet.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgBreakPoints dialog
class CDlgBreakPoints : public CDialog
{
friend class CCESimDoc;

private:
	int		m_nOrigCases;
	int		m_nCases;
	int		m_nBreakpoints;
	bool	m_invalid_case_class;
	CDWordArray m_cases; // pripady, ktere zustaly
	CDWordArray m_breakpoints; // indexy do pole pripadu
	CArray<CSetConditions,CSetConditions&>	m_case_class; // original case class
private:
	void Reset();
	void ShowSets();

public:
	void InvalidCaseClass()		{ m_invalid_case_class=true; }
	bool IsCaseClassInvalid()	{ return m_invalid_case_class; }
	bool TestBreakpoint(CSetConditions& case_set);

public:
	CDlgBreakPoints(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgBreakPoints)
	enum { IDD = IDD_BREAKPOINTS };
	CButton	m_btn_clear;
	CButton	m_btn_del;
	CButton	m_btn_add;
	CListBox	m_list_breakpoints;
	CListBox	m_list_cases;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgBreakPoints)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgBreakPoints)
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnAdd();
	afx_msg void OnBtnDel();
	afx_msg void OnBtnClear();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGBREAKPOINTS_H__431AD5E5_9522_4F2B_A870_7962BDF479CB__INCLUDED_)

